<?php

/**
 * detalle_reembolso actions.
 *
 * @package    controlComisiones
 * @subpackage detalle_reembolso
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class detalle_reembolsoActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'COM_DETA_REEMBOLSO','COM_REEMBOLSO', 'COM_PAGO_EGRESO', 'COM_CUENTA_V','PR_RUBRO_PRESUP_V','PROYECTOS','OBJETOS_GASTO'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'COM_REEMBOLSO' =>
        array(
            'id_reembolso' => 'COM_DETA_REEMBOLSO'
        ),
        'COM_PAGO_EGRESO' =>
        array(
            'id_pago_egreso' => 'COM_DETA_REEMBOLSO'
        ),
        'COM_CUENTA_V' =>
        array(
            'id_cuenta' => 'COM_PAGO_EGRESO'
        ),
        'PR_RUBRO_PRESUP_V' =>
        array(
            'id_rubro' => 'COM_DETA_REEMBOLSO'
        ),
        'PROYECTOS' =>
        array(
            'id_proyecto-id' => 'COM_REEMBOLSO'
        ),
        'OBJETOS_GASTO' =>
        array(
            'id_obj_gasto-id' => 'COM_DETA_REEMBOLSO'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'COM_DETA_REEMBOLSO'=>
        array(
         
            'id_deta_reembolso' => 'id_deta_reembolso',
            'id_reembolso' => 'id_reembolso',
            'id_rubro' => 'id_rubro',
            'id_obj_gasto' => 'id_obj_gasto',
            'valor_reembolso' => 'valor_reembolso'
        ),
        'COM_REEMBOLSO' =>
        array(
            'id_anhos' => 'id_anhos',
            'fecha_reembolso' => 'fecha_reembolso',
            'no_reembolso' => 'no_reembolso',
            'id_proyecto' => 'id_proyecto'
            
        ),
        'COM_PAGO_EGRESO' =>
        array(
            'id_cuenta' => 'id_cuenta',
            'no_pago' => 'no_pago',
            'fecha_pago' => 'fecha_pago',
            'valor_neto' => 'valor_neto',
        ),
        'COM_CUENTA_V' =>
        array(
            'id_resolucion' => 'id_resolucion',
            'no_cuenta' => 'no_cuenta',
            'fecha_cuenta' => 'fecha_cuenta',
            'id_tercero' => 'id_tercero',
            'valor' => 'valor'
        ),
        'PR_RUBRO_PRESUP_V' =>
        array(
            'rubro' => 'rubro',
            'descripcion' => 'descripcion_rubro'
        ),
        'PROYECTOS' =>
        array(
            'descripcion' => 'descripcion_cm',
            'codigo' => 'codigo_cm'
        ),
        'OBJETOS_GASTO' =>
        array(
            'codigo' => 'codigo_ob',
            'descripcion' =>'descripcion_obj'
        )
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
    ); //campos para el ordenamiento de la consulta
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'COM_DETA_REEMBOLSO' =>
        array(
            'id_deta_reembolso,a' => array('!=' => array(-1)),
            'id_deta_reembolso,b' => array('=' => array('id_deta_reembolso')),
            'id_reembolso' => array('=' => array('id_reembolso')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or
    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;
    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_deta_reembolso'; //identificador de la tabla
    protected $id_names = array('id_deta_reembolso'); //llave primaria
    protected $field_names = array('id_reembolso', 'id_proyecto', 'id_rubro', 'id_obj_gasto','valor_reembolso'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'COM_DETA_REEMBOLSO'; //tabla en la cual se aplican los cambios 
    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_deta_reembolso'; //identificador unico de la tabla

    protected function postprocessRequest($Action, \sfWebRequest $request, $list_data_post) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function preprocessRequest($Action, \sfWebRequest $request) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function validateAdd(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        

        return $errors;
    }

    protected function validateRemove(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        
        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateUpdate(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }
}
